create schema spider;

create table if not exists proxy_info
(
	id bigint not null comment 'ID'
		primary key,
	ip varchar(20) null comment 'IP',
	port int null comment '端口',
	anonymity varchar(10) null comment '匿名度',
	type varchar(10) null comment '类型',
	location varchar(100) null comment '位置',
	speed bigint null comment '响应速度',
	update_time datetime null comment '最后验证时间',
	update_at timestamp default CURRENT_TIMESTAMP not null on update CURRENT_TIMESTAMP comment '最后更新时间',
	create_at datetime not null comment '创建时间'
)
comment '代理信息' charset=utf8mb4;

create table if not exists qian_li_ma_content
(
	id bigint not null comment 'ID'
		primary key,
	content_id int not null comment '项目id',
	prog_name varchar(20) null comment '项目类型名称',
	update_time date null comment '项目更新时间',
	url varchar(500) null comment '项目详情页链接',
	area_id int null comment '区域id',
	area_name varchar(50) null comment '区域名称',
	title varchar(500) null comment '项目标题',
	prog_id int null comment '项目类型编号',
	cat_id int null comment '项目类别编号',
	is_concern int null comment '是否影响',
	province varchar(50) null comment '省份',
	city varchar(50) null comment '城市',
	status varchar(20) null comment '项目状态',
	text longtext null comment '项目正文',
	update_at timestamp default CURRENT_TIMESTAMP not null on update CURRENT_TIMESTAMP comment '最后更新时间',
	create_at datetime not null comment '创建时间'
)
comment '千里马项目内容' charset=utf8mb4;